
#ifndef  CLIB_DATATYPES_PROTOS_H
#define  CLIB_DATATYPES_PROTOS_H 1

/*
** $VER: datatypes_protos.h 45.1 (12.3.97)
** datatypes V45
**
** C prototypes. For use with 32 bit integers only.
**
** Written by Roland Mainz
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif /* !EXEC_TYPES_H */

#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif /* !EXEC_LISTS_H */

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif /* !INTUITION_INTUITION_H */

#ifndef INTUITION_CLASSES_H
#include <intuition/classes.h>
#endif /* !INTUITION_CLASSES_H */

#ifndef INTUITION_CLASSUSR_H
#include <intuition/classusr.h>
#endif /* !INTUITION_CLASSUSR_H */

#ifndef INTUITION_GADGETCLASS_H
#include <intuition/gadgetclass.h>
#endif /* !INTUITION_GADGETCLASS_H */

#ifndef UTILITY_TAGITEM_H
#include <utility/tagitem.h>
#endif /* !UTILITY_TAGITEM_H */

#ifndef DATATYPES_DATATYPES_H
#include <datatypes/datatypes.h>
#endif /* !DATATYPES_DATATYPES_H */

#ifndef REXX_STORAGE_H
#include <rexx/storage.h>
#endif /* !REXX_STORAGE_H */

/*** functions in V40 or higher (CBM Release 3.1) ***/

struct DataType *ObtainDataTypeA( ULONG, APTR, struct TagItem * );
struct DataType *ObtainDataType( ULONG, APTR, Tag, ... );
void             ReleaseDataType( struct DataType * );
Object          *NewDTObjectA( APTR, struct TagItem * );
Object          *NewDTObject( APTR, Tag, ... );
void             DisposeDTObject( Object * );
ULONG            SetDTAttrsA( Object *, struct Window *, struct Requester *, struct TagItem * );
ULONG            SetDTAttrs( Object *, struct Window *, struct Requester *, Tag, ... );
ULONG            GetDTAttrsA( Object *, struct TagItem * );
ULONG            GetDTAttrs( Object *, Tag, ... );
LONG             AddDTObject( struct Window *, struct Requester *, Object *, LONG );
void             RefreshDTObjectA( Object *, struct Window *, struct Requester *, struct TagItem * );
void             RefreshDTObjects( Object *, struct Window *, struct Requester *, Tag, ... );
ULONG            DoAsyncLayout( Object *, struct gpLayout * );
ULONG            DoDTMethodA( Object *, struct Window *, struct Requester *, Msg );
ULONG            DoDTMethod( Object *, struct Window *, struct Requester *, ULONG, ... );
LONG             RemoveDTObject( struct Window *, Object * );
ULONG           *GetDTMethods( Object * );
struct DTMethod *GetDTTriggerMethods( Object * );
ULONG            PrintDTObjectA( Object *, struct Window *, struct Requester *, struct dtPrint * );
ULONG            PrintDTObject( Object *, struct Window *, struct Requester *, ULONG, ... );
APTR             ObtainDTDrawInfoA( Object *, struct TagItem * );
APTR             ObtainDTDrawInfo( Object *, Tag, ... );
LONG             DrawDTObjectA( struct RastPort *, Object *, LONG, LONG, LONG, LONG, LONG, LONG, struct TagItem * );
LONG             DrawDTObject( struct RastPort *, Object *, LONG, LONG, LONG, LONG, LONG, LONG, Tag, ... );
VOID             ReleaseDTDrawInfo( Object *, APTR );
STRPTR           GetDTString( ULONG );

/*** functions in V45 or higher ***/
void             LockDataType( struct DataType * );
struct ToolNode *FindToolNodeA( struct List *, struct TagItem * );
struct ToolNode *FindToolNode( struct List *, Tag, ... );
ULONG            LaunchToolA( struct Tool *, STRPTR, struct TagItem * );
ULONG            LaunchTool( struct Tool *, STRPTR, Tag, ... );
ULONG           *FindMethod( ULONG *, ULONG );
struct DTMethod *FindTriggerMethod( struct DTMethod *, STRPTR, ULONG );
ULONG           *CopyDTMethods( ULONG *, ULONG *, ULONG * );
struct DTMethod *CopyDTTriggerMethods( struct DTMethod *, struct DTMethod *, struct DTMethod * );
VOID             FreeDTMethods( APTR );
ULONG            GetDTTriggerMethodDataFlags( ULONG );
ULONG            SaveDTObjectA( Object *, struct Window *, struct Requester *, STRPTR, ULONG, BOOL, struct TagItem * );
ULONG            SaveDTObject( Object *, struct Window *, struct Requester *, STRPTR, ULONG, BOOL, Tag, ... );
ULONG            StartDragSelect( Object * );
ULONG            DoDTDomainA( Object *, struct Window *, struct Requester *, struct RastPort *, ULONG, struct IBox *, struct TagItem *attrs );
ULONG            DoDTDomain( Object *, struct Window *, struct Requester *, struct RastPort *, ULONG, struct IBox *, Tag, ... );

#endif /* !CLIB_DATATYPES_PROTOS_H */




