/* $VER: dtdescrlist.rexx 1.1 (24.5.97) */

PARSE ARG type
OPTIONS RESULTS

/* Load the datatypes.library as a function host */
IF ~SHOW( 'L', 'datatypes.library' ) THEN
   CALL ADDLIB( 'datatypes.library', 0, -30 )

   IF type="?" THEN DO
      SAY "Usage:"
      SAY "  rx dtdescrlist <type>, type is one of [System|Text|Document|Sound|Instrument|Music|Picture|Animation|Movie]"

      EXIT 5
   END

   prevdt = ""

   Do FOREVER
     IF ObtainDataType( RAM,, dtstem., prevdt, type ) > 0 THEN LEAVE

     prevdt = dtstem.header.name

     SAY '------------------'

     SAY '             Name:' dtstem.header.name
     SAY '         Basename:' dtstem.header.basename
     SAY '          Pattern:' dtstem.header.pattern
     SAY '          GroupID:' dtstem.header.groupid
     SAY '               ID:' dtstem.header.id
     SAY '         Basetype:' dtstem.header.basetype
     SAY '     Functionname:' dtstem.functionname

     /*  ATTRLIST not set up in V45 */

     DO i = 0 TO (dtstem.toollist.count - 1)
       SAY 'Tool Node ' i
       SAY '  --      Program:' dtstem.toollist.i.program
       SAY '            Which:' dtstem.toollist.i.which
       SAY '           Launch:' dtstem.toollist.i.launch
       SAY '            Flags:' dtstem.toollist.i.flags
     END /* DO toollist.count */

     DROP dtstem. /* flush vars */
   END /* DO FOREVER */
EXIT

